/*
 * QEMU model of the AMS Registers for Analog Monitor System
 *
 * Copyright (c) 2014 Xilinx Inc.
 *
 * Autogenerated by xregqemu.py 2014-01-21.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
 * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */

#include "qemu/osdep.h"
#include "hw/sysbus.h"
#include "hw/register-dep.h"
#include "qemu/bitops.h"
#include "qemu/log.h"

#ifndef XILINX_AMS_ERR_DEBUG
#define XILINX_AMS_ERR_DEBUG 0
#endif

#define TYPE_XILINX_AMS "xlnx.zynqmp_ams"

#define XILINX_AMS(obj) \
     OBJECT_CHECK(AMS, (obj), TYPE_XILINX_AMS)

DEP_REG32(MISC_CTRL, 0x0)
    DEP_FIELD(MISC_CTRL, SLVERR_ENABLE, 1, 0)
DEP_REG32(ISR, 0x4)
    DEP_FIELD(ISR, ADDR_DECODE_ERR, 1, 31)
    DEP_FIELD(ISR, PL_OT, 1, 23)
    DEP_FIELD(ISR, PL_ALM_6, 1, 22)
    DEP_FIELD(ISR, PL_ALM_5, 1, 21)
    DEP_FIELD(ISR, PL_ALM_4, 1, 20)
    DEP_FIELD(ISR, PL_ALM_3, 1, 19)
    DEP_FIELD(ISR, PL_ALM_2, 1, 18)
    DEP_FIELD(ISR, PL_ALM_1, 1, 17)
    DEP_FIELD(ISR, PL_ALM_0, 1, 16)
    DEP_FIELD(ISR, EOS_ADC1, 1, 15)
    DEP_FIELD(ISR, EOS_ADC0, 1, 14)
    DEP_FIELD(ISR, EOC_ADC1, 1, 13)
    DEP_FIELD(ISR, EOC_ADC0, 1, 12)
    DEP_FIELD(ISR, PS_SYSMON_OT, 1, 11)
    DEP_FIELD(ISR, PS_OT, 1, 10)
    DEP_FIELD(ISR, PS_ALM_9, 1, 9)
    DEP_FIELD(ISR, PS_ALM_8, 1, 8)
    DEP_FIELD(ISR, PS_ALM_7, 1, 7)
    DEP_FIELD(ISR, PS_ALM_6, 1, 6)
    DEP_FIELD(ISR, PS_ALM_5, 1, 5)
    DEP_FIELD(ISR, PS_ALM_4, 1, 4)
    DEP_FIELD(ISR, PS_ALM_3, 1, 3)
    DEP_FIELD(ISR, PS_ALM_2, 1, 2)
    DEP_FIELD(ISR, PS_ALM_1, 1, 1)
    DEP_FIELD(ISR, PS_ALM_0, 1, 0)
DEP_REG32(IMR, 0x8)
    DEP_FIELD(IMR, ADDR_DECODE_ERR, 1, 31)
    DEP_FIELD(IMR, PL_OT, 1, 23)
    DEP_FIELD(IMR, PL_ALM_6, 1, 22)
    DEP_FIELD(IMR, PL_ALM_5, 1, 21)
    DEP_FIELD(IMR, PL_ALM_4, 1, 20)
    DEP_FIELD(IMR, PL_ALM_3, 1, 19)
    DEP_FIELD(IMR, PL_ALM_2, 1, 18)
    DEP_FIELD(IMR, PL_ALM_1, 1, 17)
    DEP_FIELD(IMR, PL_ALM_0, 1, 16)
    DEP_FIELD(IMR, EOS_ADC1, 1, 15)
    DEP_FIELD(IMR, EOS_ADC0, 1, 14)
    DEP_FIELD(IMR, EOC_ADC1, 1, 13)
    DEP_FIELD(IMR, EOC_ADC0, 1, 12)
    DEP_FIELD(IMR, PS_SYSMON_OT, 1, 11)
    DEP_FIELD(IMR, PS_OT, 1, 10)
    DEP_FIELD(IMR, PS_ALM_9, 1, 9)
    DEP_FIELD(IMR, PS_ALM_8, 1, 8)
    DEP_FIELD(IMR, PS_ALM_7, 1, 7)
    DEP_FIELD(IMR, PS_ALM_6, 1, 6)
    DEP_FIELD(IMR, PS_ALM_5, 1, 5)
    DEP_FIELD(IMR, PS_ALM_4, 1, 4)
    DEP_FIELD(IMR, PS_ALM_3, 1, 3)
    DEP_FIELD(IMR, PS_ALM_2, 1, 2)
    DEP_FIELD(IMR, PS_ALM_1, 1, 1)
    DEP_FIELD(IMR, PS_ALM_0, 1, 0)
DEP_REG32(IER, 0xc)
    DEP_FIELD(IER, ADDR_DECODE_ERR, 1, 31)
    DEP_FIELD(IER, PL_OT, 1, 23)
    DEP_FIELD(IER, PL_ALM_6, 1, 22)
    DEP_FIELD(IER, PL_ALM_5, 1, 21)
    DEP_FIELD(IER, PL_ALM_4, 1, 20)
    DEP_FIELD(IER, PL_ALM_3, 1, 19)
    DEP_FIELD(IER, PL_ALM_2, 1, 18)
    DEP_FIELD(IER, PL_ALM_1, 1, 17)
    DEP_FIELD(IER, PL_ALM_0, 1, 16)
    DEP_FIELD(IER, EOS_ADC1, 1, 15)
    DEP_FIELD(IER, EOS_ADC0, 1, 14)
    DEP_FIELD(IER, EOC_ADC1, 1, 13)
    DEP_FIELD(IER, EOC_ADC0, 1, 12)
    DEP_FIELD(IER, PS_SYSMON_OT, 1, 11)
    DEP_FIELD(IER, PS_OT, 1, 10)
    DEP_FIELD(IER, PS_ALM_9, 1, 9)
    DEP_FIELD(IER, PS_ALM_8, 1, 8)
    DEP_FIELD(IER, PS_ALM_7, 1, 7)
    DEP_FIELD(IER, PS_ALM_6, 1, 6)
    DEP_FIELD(IER, PS_ALM_5, 1, 5)
    DEP_FIELD(IER, PS_ALM_4, 1, 4)
    DEP_FIELD(IER, PS_ALM_3, 1, 3)
    DEP_FIELD(IER, PS_ALM_2, 1, 2)
    DEP_FIELD(IER, PS_ALM_1, 1, 1)
    DEP_FIELD(IER, PS_ALM_0, 1, 0)
DEP_REG32(IDR, 0x10)
    DEP_FIELD(IDR, ADDR_DECODE_ERR, 1, 31)
    DEP_FIELD(IDR, PL_OT, 1, 23)
    DEP_FIELD(IDR, PL_ALM_6, 1, 22)
    DEP_FIELD(IDR, PL_ALM_5, 1, 21)
    DEP_FIELD(IDR, PL_ALM_4, 1, 20)
    DEP_FIELD(IDR, PL_ALM_3, 1, 19)
    DEP_FIELD(IDR, PL_ALM_2, 1, 18)
    DEP_FIELD(IDR, PL_ALM_1, 1, 17)
    DEP_FIELD(IDR, PL_ALM_0, 1, 16)
    DEP_FIELD(IDR, EOS_ADC1, 1, 15)
    DEP_FIELD(IDR, EOS_ADC0, 1, 14)
    DEP_FIELD(IDR, EOC_ADC1, 1, 13)
    DEP_FIELD(IDR, EOC_ADC0, 1, 12)
    DEP_FIELD(IDR, PS_SYSMON_OT, 1, 11)
    DEP_FIELD(IDR, PS_OT, 1, 10)
    DEP_FIELD(IDR, PS_ALM_9, 1, 9)
    DEP_FIELD(IDR, PS_ALM_8, 1, 8)
    DEP_FIELD(IDR, PS_ALM_7, 1, 7)
    DEP_FIELD(IDR, PS_ALM_6, 1, 6)
    DEP_FIELD(IDR, PS_ALM_5, 1, 5)
    DEP_FIELD(IDR, PS_ALM_4, 1, 4)
    DEP_FIELD(IDR, PS_ALM_3, 1, 3)
    DEP_FIELD(IDR, PS_ALM_2, 1, 2)
    DEP_FIELD(IDR, PS_ALM_1, 1, 1)
    DEP_FIELD(IDR, PS_ALM_0, 1, 0)
DEP_REG32(ITR, 0x14)
    DEP_FIELD(ITR, ADDR_DECODE_ERR, 1, 31)
    DEP_FIELD(ITR, PL_OT, 1, 23)
    DEP_FIELD(ITR, PL_ALM_6, 1, 22)
    DEP_FIELD(ITR, PL_ALM_5, 1, 21)
    DEP_FIELD(ITR, PL_ALM_4, 1, 20)
    DEP_FIELD(ITR, PL_ALM_3, 1, 19)
    DEP_FIELD(ITR, PL_ALM_2, 1, 18)
    DEP_FIELD(ITR, PL_ALM_1, 1, 17)
    DEP_FIELD(ITR, PL_ALM_0, 1, 16)
    DEP_FIELD(ITR, EOS_ADC1, 1, 15)
    DEP_FIELD(ITR, EOS_ADC0, 1, 14)
    DEP_FIELD(ITR, EOC_ADC1, 1, 13)
    DEP_FIELD(ITR, EOC_ADC0, 1, 12)
    DEP_FIELD(ITR, PS_SYSMON_OT, 1, 11)
    DEP_FIELD(ITR, PS_OT, 1, 10)
    DEP_FIELD(ITR, PS_ALM_9, 1, 9)
    DEP_FIELD(ITR, PS_ALM_8, 1, 8)
    DEP_FIELD(ITR, PS_ALM_7, 1, 7)
    DEP_FIELD(ITR, PS_ALM_6, 1, 6)
    DEP_FIELD(ITR, PS_ALM_5, 1, 5)
    DEP_FIELD(ITR, PS_ALM_4, 1, 4)
    DEP_FIELD(ITR, PS_ALM_3, 1, 3)
    DEP_FIELD(ITR, PS_ALM_2, 1, 2)
    DEP_FIELD(ITR, PS_ALM_1, 1, 1)
    DEP_FIELD(ITR, PS_ALM_0, 1, 0)
DEP_REG32(PS_SYSMON_CONTROL_STATUS, 0x20)
    DEP_FIELD(PS_SYSMON_CONTROL_STATUS, STARTUP_STATE, 4, 24)
    DEP_FIELD(PS_SYSMON_CONTROL_STATUS, STARTUP_DONE, 1, 16)
    DEP_FIELD(PS_SYSMON_CONTROL_STATUS, AUTO_CONVST, 1, 3)
    DEP_FIELD(PS_SYSMON_CONTROL_STATUS, CONVST, 1, 2)
    DEP_FIELD(PS_SYSMON_CONTROL_STATUS, SYSMON_RESET, 1, 1)
    DEP_FIELD(PS_SYSMON_CONTROL_STATUS, STARTUP_TRIGGER, 1, 0)
DEP_REG32(PL_SYSMON_CONTROL_STATUS, 0x24)
    DEP_FIELD(PL_SYSMON_CONTROL_STATUS, ACCESSIBLE, 1, 0)
DEP_REG32(OSC, 0x28)
    DEP_FIELD(OSC, CTRL, 8, 0)
DEP_REG32(MON_STATUS, 0x30)
    DEP_FIELD(MON_STATUS, JTAG_MODIFIED, 1, 24)
    DEP_FIELD(MON_STATUS, JTAG_LOCKED, 1, 23)
    DEP_FIELD(MON_STATUS, JTAG_BUSY, 1, 22)
    DEP_FIELD(MON_STATUS, BUSY, 1, 21)
    DEP_FIELD(MON_STATUS, CHANNEL, 5, 16)
    DEP_FIELD(MON_STATUS, MON_DATA, 16, 0)
DEP_REG32(TEST_ATTR_A, 0x40)
    DEP_FIELD(TEST_ATTR_A, RSVD, 11, 5)
    DEP_FIELD(TEST_ATTR_A, TEST_CHAR_IO_ENABLE, 1, 4)
    DEP_FIELD(TEST_ATTR_A, TEST_ANALOG_IO_ENABLE, 1, 3)
    DEP_FIELD(TEST_ATTR_A, TEST_SCAN_IO_ENABLE, 1, 2)
    DEP_FIELD(TEST_ATTR_A, TEST_JTAG_IO_ENABLE, 1, 1)
    DEP_FIELD(TEST_ATTR_A, DRP_IO_ENABLE, 1, 0)
DEP_REG32(TEST_ATTR_B, 0x44)
    DEP_FIELD(TEST_ATTR_B, TEST_ATTR_B, 16, 0)
DEP_REG32(TEST_ATTR_C, 0x48)
    DEP_FIELD(TEST_ATTR_C, TEST_ATTR_C, 16, 0)
DEP_REG32(TEST_ATTR_D, 0x4c)
    DEP_FIELD(TEST_ATTR_D, TEST_ATTR_D, 16, 0)
DEP_REG32(TEST_ATTR_E, 0x50)
    DEP_FIELD(TEST_ATTR_E, RSVD, 8, 8)
    DEP_FIELD(TEST_ATTR_E, JTAG_READ_ONLY1, 2, 6)
    DEP_FIELD(TEST_ATTR_E, DRP_TEST_STATUS_BITS, 1, 5)
    DEP_FIELD(TEST_ATTR_E, DRP_NO_CLOCK_SWITCH, 1, 4)
    DEP_FIELD(TEST_ATTR_E, JTAG_READ_ONLY0, 1, 3)
    DEP_FIELD(TEST_ATTR_E, JTAG_DISABLE, 3, 0)
DEP_REG32(ECO_0, 0x60)
DEP_REG32(ECO_1, 0x64)

#define R_MAX (R_ECO_1 + 1)

typedef struct AMS {
    SysBusDevice parent_obj;
    MemoryRegion iomem;
    qemu_irq irq_isr;

    uint32_t regs[R_MAX];
    DepRegisterInfo regs_info[R_MAX];
} AMS;

static const MemoryRegionOps ams_ops = {
    .read = dep_register_read_memory_le,
    .write = dep_register_write_memory_le,
    .endianness = DEVICE_LITTLE_ENDIAN,
    .valid = {
        .min_access_size = 4,
        .max_access_size = 4,
    },
};

static void isr_update_irq(AMS *s)
{
    bool pending = s->regs[R_ISR] & ~s->regs[R_IMR];
    qemu_set_irq(s->irq_isr, pending);
}

static void isr_postw(DepRegisterInfo *reg, uint64_t val64)
{
    AMS *s = XILINX_AMS(reg->opaque);
    isr_update_irq(s);
}

static uint64_t ier_prew(DepRegisterInfo *reg, uint64_t val64)
{
    AMS *s = XILINX_AMS(reg->opaque);
    uint32_t val = val64;

    s->regs[R_IMR] &= ~val;
    isr_update_irq(s);
    return 0;
}

static uint64_t idr_prew(DepRegisterInfo *reg, uint64_t val64)
{
    AMS *s = XILINX_AMS(reg->opaque);
    uint32_t val = val64;

    s->regs[R_IMR] |= val;
    isr_update_irq(s);
    return 0;
}

static uint64_t itr_prew(DepRegisterInfo *reg, uint64_t val64)
{
    AMS *s = XILINX_AMS(reg->opaque);
    uint32_t val = val64;

    s->regs[R_ISR] |= val;
    isr_update_irq(s);
    return 0;
}

static DepRegisterAccessInfo ams_regs_info[] = {
    {   .name = "MISC_CTRL",  .decode.addr = A_MISC_CTRL,
    },{ .name = "ISR",  .decode.addr = A_ISR,
        .rsvd = 0x7f000000,
        .ro = 0x7f000000,
        .w1c = 0x80ffffffL,
        .post_write = isr_postw,
    },{ .name = "IMR",  .decode.addr = A_IMR,
        .reset = 0x81ffffffL,
        .rsvd = 0x7f000000,
        .ro = 0xffffffffL,
    },{ .name = "IER",  .decode.addr = A_IER,
        .rsvd = 0x7f000000,
        .pre_write = ier_prew,
    },{ .name = "IDR",  .decode.addr = A_IDR,
        .rsvd = 0x7f000000,
        .pre_write = idr_prew,
    },{ .name = "ITR",  .decode.addr = A_ITR,
        .rsvd = 0x7f000000,
        .pre_write = itr_prew,
    },{ .name = "PS_SYSMON_CONTROL_STATUS",  .decode.addr = A_PS_SYSMON_CONTROL_STATUS,
        .reset = 0x2,
        .rsvd = 0xfefff0,
        .ro = 0xffffff0,
    },{ .name = "PL_SYSMON_CONTROL_STATUS",  .decode.addr = A_PL_SYSMON_CONTROL_STATUS,
        .ro = 0x1,
    },{ .name = "OSC",  .decode.addr = A_OSC,
    },{ .name = "MON_STATUS",  .decode.addr = A_MON_STATUS,
        .ro = 0x1ffffff,
    },{ .name = "TEST_ATTR_A",  .decode.addr = A_TEST_ATTR_A,
        .reset = 0x1,
    },{ .name = "TEST_ATTR_B",  .decode.addr = A_TEST_ATTR_B,
    },{ .name = "TEST_ATTR_C",  .decode.addr = A_TEST_ATTR_C,
    },{ .name = "TEST_ATTR_D",  .decode.addr = A_TEST_ATTR_D,
    },{ .name = "TEST_ATTR_E",  .decode.addr = A_TEST_ATTR_E,
    },{ .name = "ECO_0",  .decode.addr = A_ECO_0,
    },{ .name = "ECO_1",  .decode.addr = A_ECO_1,
        .reset = 0xffffffffL,
    }
};

static void ams_reset(DeviceState *dev)
{
    AMS *s = XILINX_AMS(dev);
    unsigned int i;

    for (i = 0; i < ARRAY_SIZE(s->regs_info); ++i) {
        dep_register_reset(&s->regs_info[i]);
    }

    isr_update_irq(s);
}

static void ams_realize(DeviceState *dev, Error **errp)
{
    AMS *s = XILINX_AMS(dev);
    const char *prefix = object_get_canonical_path(OBJECT(dev));
    unsigned int i;

    for (i = 0; i < ARRAY_SIZE(ams_regs_info); ++i) {
        DepRegisterInfo *r = &s->regs_info[i];

        *r = (DepRegisterInfo) {
            .data = (uint8_t *)&s->regs[
                    ams_regs_info[i].decode.addr/4],
            .data_size = sizeof(uint32_t),
            .access = &ams_regs_info[i],
            .debug = XILINX_AMS_ERR_DEBUG,
            .prefix = prefix,
            .opaque = s,
        };
        memory_region_init_io(&r->mem, OBJECT(dev), &ams_ops, r,
                              r->access->name, 4);
        memory_region_add_subregion(&s->iomem, r->access->decode.addr, &r->mem);
    }
}

static void ams_init(Object *obj)
{
    AMS *s = XILINX_AMS(obj);
    SysBusDevice *sbd = SYS_BUS_DEVICE(obj);

    memory_region_init(&s->iomem, obj, TYPE_XILINX_AMS, R_MAX * 4);
    sysbus_init_mmio(sbd, &s->iomem);
    sysbus_init_irq(sbd, &s->irq_isr);
}

static const VMStateDescription vmstate_ams = {
    .name = TYPE_XILINX_AMS,
    .version_id = 1,
    .minimum_version_id = 1,
    .minimum_version_id_old = 1,
    .fields = (VMStateField[]) {
        VMSTATE_UINT32_ARRAY(regs, AMS, R_MAX),
        VMSTATE_END_OF_LIST(),
    }
};

static void ams_class_init(ObjectClass *klass, void *data)
{
    DeviceClass *dc = DEVICE_CLASS(klass);

    dc->reset = ams_reset;
    dc->realize = ams_realize;
    dc->vmsd = &vmstate_ams;
}

static const TypeInfo ams_info = {
    .name          = TYPE_XILINX_AMS,
    .parent        = TYPE_SYS_BUS_DEVICE,
    .instance_size = sizeof(AMS),
    .class_init    = ams_class_init,
    .instance_init = ams_init,
};

static void ams_register_types(void)
{
    type_register_static(&ams_info);
}

type_init(ams_register_types)
